#include <iostream>
#include <ctime>
#include <queue>
#include <iterator>
#include <set>
#include <math.h>

#include "stav.h"

using namespace std;

typedef pair<int,stav> dis;

bool operator>(const dis& lhs,const dis& rhs) {
   return (lhs.first>rhs.first);
}

void find(const stav& st, char co, int *x, int *y) {
   bool nalezeno = false;
   int i;
   i = 0;
   do {
      if (st.policko((i%3)+1,(i/3)+1) == co) {
         nalezeno = true;
      } else {
         i++;
      }
   } while (!nalezeno);
   *x = (i%3) +1;
   *y = (i/3) +1;
}      

int manh(const stav& st) {
   int chyb = 0;
   int x,y;
   for (int i = 1; i<4; i++) {
      if (st.policko(i,1) != (i + '0')) {
         find(st, i + '0', &x, &y);
         chyb += abs(i-x) + abs(1-y);
      }
   }
   for (int i = 5; i<8; i++) {
      if (st.policko(7-i,3) != (i + '0')) {
         find(st, i + '0', &x, &y);
         chyb += abs(7-i-x) + abs(3-y);
      }
   }
   if (st.policko(1,2) != (8 + '0')) {
      find(st, 8 + '0', &x, &y);
      chyb += abs(1-x) + abs(2-y);
   }
   if (st.policko(3,2) != (4 + '0')) {
      find(st, 4 + '0', &x, &y);
      chyb += abs(3-x) + abs(2-y);
   }
   return chyb;
}

int chybv(const stav& st) {
   int chyb = 0;
   for (int i = 1; i<4; i++) {
      if (st.policko(i,1) != (i + '0')) {
         chyb++;
      }
   }
   for (int i = 5; i<8; i++) {
      if (st.policko(7-i,3) != (i + '0')) {
         chyb++;
      }
   }
   if (st.policko(1,2) != (8 + '0')) {
      chyb++;
   }
   if (st.policko(3,2) != (4 + '0')) {
      chyb++;
   }
   return chyb;
}



void vyres(stav& st1, int (*heuristika)(const stav&)) {
   cout << "Stav 1:\n";
   for (int i = 0; i<9; i++) {
      cout << st1.policko((i%3) + 1, (i/3) + 1);
      if ((i%3) < 2) {
         cout << " | ";
      } else {
         cout << endl;
      }
   }
   cout << endl << endl;
   priority_queue<dis,vector<dis>,greater<dis> > fronta;
   set<string> S;
   fronta.push(dis(heuristika(st1),st1));
   S.insert(st1.hash());
   bool vyreseno = false;
   stav vysledek;
   stav *as,*sr,*sl,*su,*sd;
   int pocet_stavu = 0;   
   
   while (!vyreseno) {
      as = new stav(fronta.top().second);fronta.pop();
       
      sl = new stav(*as);sr = new stav(*as); su = new stav(*as); sd = new stav(*as);
      if (sl->doleva()) {
         if (S.find(sl->hash()) == S.end()) {
            pocet_stavu++;
            if (sl->konec()) {
               vysledek = *sl;
               vyreseno = true;
            } else {
               fronta.push(dis(heuristika(*sl) + sl->pohybu(),*sl));
               S.insert(sl->hash());
            }
         }
      }
      if (sr->doprava()){
         if (S.find(sr->hash()) == S.end()) {
            pocet_stavu++;
            if (sr->konec()) {
               vysledek = *sr;
               vyreseno = true;
            } else {
               fronta.push(dis(heuristika(*sr) + sr->pohybu(),*sr));
               S.insert(sr->hash());
            }
         }
      }
      if (sd->dolu()) {
         if (S.find(sd->hash()) == S.end()) {
            pocet_stavu++;
            if (sd->konec()) {
               vysledek = *sd;
               vyreseno = true;
            } else {
               fronta.push(dis(heuristika(*sd) + sl->pohybu(),*sd));
               S.insert(sd->hash());
            }
         }
      }
      if (su->nahoru()) {
         if (S.find(su->hash()) == S.end()) {
            pocet_stavu++;
            if (su->konec()) {
               vysledek = *su;
               vyreseno = true;
            } else {
               fronta.push(dis(heuristika(*su) + su->pohybu(),*su));
               S.insert(su->hash());
            }
         }
      }
      
   }
   cout << "Vysledek 1:\n";
   for (int i = 0; i<9; i++) {
      cout << vysledek.policko((i%3) + 1, (i/3) + 1);
      if ((i%3) < 2) {
         cout << " | ";
      } else {
         cout << endl;
      }
   }
   cout << "Historie: " << vysledek.historie() <<"\nPocet stavu: " << pocet_stavu << endl;
}

int main() {
   stav st[5];
   for (int i = 0; i<5; i++) {
      cout << "Chybna vzdalenost:\n";
      vyres(st[i],chybv);
      cout << "Manhatton:\n";
      vyres(st[i],manh);
   }
   return 0;
}
